package com.cinema.cinemarental.activities

import android.content.Intent
import android.os.Bundle
import android.view.View
import android.widget.Toast
import com.google.android.material.tabs.TabLayout
import androidx.viewpager.widget.ViewPager
import androidx.appcompat.app.AppCompatActivity
import com.cinema.cinemarental.R
import com.cinema.cinemarental.activities.ui.main.SectionsPagerAdapter
import com.google.android.material.floatingactionbutton.ExtendedFloatingActionButton

class MainActivity : AppCompatActivity() {

    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        setContentView(R.layout.activity_main)

        val fab: ExtendedFloatingActionButton = findViewById(R.id.fab)

        val sectionsPagerAdapter = SectionsPagerAdapter(this, supportFragmentManager)
        val viewPager: ViewPager = findViewById(R.id.view_pager)
        viewPager.adapter = sectionsPagerAdapter
        val tabs: TabLayout = findViewById(R.id.tabs)
        tabs.setupWithViewPager(viewPager)

        tabs.addOnTabSelectedListener(object: TabLayout.OnTabSelectedListener{
            override fun onTabReselected(tab: TabLayout.Tab?) {

            }

            override fun onTabUnselected(tab: TabLayout.Tab?) {

            }

            override fun onTabSelected(tab: TabLayout.Tab?) {
                if (tab != null) {
                    if(tab.text.toString().equals(getString(R.string.tab_text_4))) fab.visibility = View.GONE
                    else fab.visibility = View.VISIBLE
                }
            }

        })

        fab.setOnClickListener { view ->
            val intent = Intent(this, NewRentalActivity::class.java)
            startActivity(intent)
        }
    }

    override fun onBackPressed() {

    }
}