package com.cinema.cinemarental.model

import android.graphics.Bitmap
import com.cinema.cinemarental.util.References
import com.google.firebase.auth.FirebaseAuth
import com.google.firebase.auth.ktx.auth
import com.google.firebase.ktx.Firebase
import com.google.firebase.storage.StorageReference
import java.io.ByteArrayOutputStream

class StorageModel {
    companion object {
        private var auth: FirebaseAuth = Firebase.auth
        private var storageRef: StorageReference = References.getStorageReference()

        fun saveImage(bitmap: Bitmap, num: Int, title: String) {
            val baos = ByteArrayOutputStream()
            bitmap.compress(Bitmap.CompressFormat.JPEG, 50, baos)
            val data = baos.toByteArray()
            if (num != 0) storageRef.child("${auth.currentUser?.displayName}/${title}/image$num").putBytes(data)
            else storageRef.child("${auth.currentUser?.displayName}/profile").putBytes(data)
        }
    }
}