package com.cinema.cinemarental.model

import android.util.Log
import android.widget.RatingBar
import android.widget.TextView
import com.cinema.cinemarental.activities.ui.main.ProfileFragment
import com.cinema.cinemarental.util.References
import com.google.firebase.auth.FirebaseAuth
import com.google.firebase.auth.ktx.auth
import com.google.firebase.database.DataSnapshot
import com.google.firebase.database.DatabaseError
import com.google.firebase.database.ValueEventListener
import com.google.firebase.ktx.Firebase
import java.text.SimpleDateFormat
import java.util.*
import kotlin.collections.HashMap

class UserModel {
    companion object {

        private var auth: FirebaseAuth = Firebase.auth

        fun getRatingAverage(user: String, ratingBar: RatingBar, numComments: TextView) {
            var commentsRef = References.getDatabaseReference("comments/${user}")
            commentsRef.addValueEventListener(object : ValueEventListener {
                override fun onDataChange(snapshot: DataSnapshot) {
                    var sum : Double = 0.0
                    var cont : Long = 0

                    for (item in snapshot.children) {
                        val itemMap: HashMap<String, Objects> = item.value as HashMap<String, Objects>

                        val rating: Double = java.lang.Double.parseDouble(itemMap.get("rating").toString())

                        sum += rating
                        cont += 1
                    }

                    if(cont != 0L) {
                        ratingBar.setRating((sum / cont).toFloat())
                        numComments.text = cont.toString()
                    }
                }
                override fun onCancelled(error: DatabaseError) {
                    Log.d(ProfileFragment.TAG, error.message)
                }
            })
        }

        fun sendComment(user: String, numStars: Float, message: String) {
            val commentsRef = References.getDatabaseReference("comments")

            val currentDate = SimpleDateFormat("dd-MM-yyyy hh:mm:ss").format(Date()).toString()
            val map = HashMap<String, Any>()
            map.put("$user/${auth.currentUser?.displayName.toString()}-$currentDate/comment", message)
            map.put("$user/${auth.currentUser?.displayName.toString()}-$currentDate/from", auth.currentUser?.displayName.toString())
            map.put("$user/${auth.currentUser?.displayName.toString()}-$currentDate/rating", numStars)
            map.put("$user/${auth.currentUser?.displayName.toString()}-$currentDate/date", currentDate)

            commentsRef.updateChildren(map)
        }
    }
}