package com.cinema.cinemarental.ui.login

import android.util.Log
import com.cinema.cinemarental.data.DtoLoggedInUser
import com.google.firebase.firestore.FirebaseFirestore
import kotlinx.coroutines.Dispatchers
import kotlinx.coroutines.GlobalScope
import kotlinx.coroutines.delay
import kotlinx.coroutines.launch
import java.io.IOException
import java.util.*

/**
 * Class that handles authentication w/ login credentials and retrieves user information.
 */
class LoginDataSource {

    private var pass : String
        get() = pass
        set(value) { pass = value}
    fun login(username: String, password: String): Result<DtoLoggedInUser> {

        val db = FirebaseFirestore.getInstance()
        try {

            val fakeUser = DtoLoggedInUser(UUID.randomUUID().toString(), "$username")

            GlobalScope.launch(context = Dispatchers.Main) {
                db.collection("users").document(username).get().addOnSuccessListener {
                    val p = it.get("password") as String
                    Log.w("LOGIN: ", "password1 $p")
                    Thread.sleep(500)
                    checkPassword(fakeUser, p, password)
                }
            }

        } catch (e: Throwable) {
            return Result.Error(IOException("Error logging in", e))
        }

        return Result.Error(IOException("Error"))
    }

    private fun checkPassword(fakeUserDto: DtoLoggedInUser, p: String, password: String): Result<out Any>? {
        if(password == p) {
            return Result.Success(fakeUserDto)
        } else {
            return Result.Error(IOException("Error logging in"))
        }
    }

    fun logout() {
        // TODO: revoke authentication
    }


    suspend fun setDelay(timeMillis: Long) {
        delay(timeMillis)
    }

}